xfs: filter and record the unknown block state messages
[xfstests-dev.git] / tests / xfs / 030
1 #! /bin/bash
2 # FS QA Test No. 030
3 #
4 # exercise xfs_repair repairing broken filesystems
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seqfull=$0
26 seq=`basename $0`
27 seqres=$RESULT_DIR/$seq
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1        # failure is the default!
33
34 _cleanup()
35 {
36         cd /
37         _scratch_unmount 2>/dev/null
38         rm -f $tmp.*
39 }
40
41 trap "_cleanup; exit \$status" 0 1 2 3 15
42
43 # get standard environment, filters and checks
44 . ./common/rc
45 . ./common/filter
46 . ./common/repair
47
48 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
49 #
50 _check_ag()
51 {
52         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
53         do
54                 echo "Corrupting $structure - setting bits to $1"
55                 _check_repair $1 "$structure" | uniq |
56                         sed -e '/^error following ag 0 unlinked list$/d' \
57                             -e '/^bad agbno AGBNO for finobt/d' \
58                             -e '/^bad agbno AGBNO for rmapbt/d' \
59                             -e '/^bad agbno AGBNO for refcntbt/d' \
60                             -e '/^Missing reverse-mapping record.*/d' \
61                             -e '/^unknown block state, ag AGNO, block.*/d'
62         done
63 }
64
65 # real QA test starts here
66 _supported_fs xfs
67 _supported_os Linux
68
69 _require_scratch
70 _require_no_large_scratch_dev
71
72 DSIZE="-dsize=100m,agcount=6"
73
74 # first we need to ensure there are no bogus secondary
75 # superblocks between the primary and first secondary
76 # superblock (hanging around from earlier tests)...
77 #
78
79 _scratch_mkfs_xfs $DSIZE >/dev/null 2>&1
80 if [ $? -ne 0 ]         # probably don't have a big enough scratch
81 then
82         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
83 else
84         _scratch_mount
85         src/feature -U $SCRATCH_DEV && \
86                 _notrun "UQuota are enabled, test needs controlled sb recovery"
87         src/feature -G $SCRATCH_DEV && \
88                 _notrun "GQuota are enabled, test needs controlled sb recovery"
89         src/feature -P $SCRATCH_DEV && \
90                 _notrun "PQuota are enabled, test needs controlled sb recovery"
91         _scratch_unmount
92 fi
93 clear=""
94 eval `xfs_db -r -c "sb 1" -c stack $SCRATCH_DEV | perl -ne '
95         if (/byte offset (\d+), length (\d+)/) {
96                 print "clear=", $1 / 512, "\n"; exit
97         }'`
98 [ -z "$clear" ] && echo "Cannot calculate length to clear"
99 src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
100
101 # now kick off the real repair test...
102 #
103 _scratch_mkfs_xfs $DSIZE | _filter_mkfs 2>$tmp.mkfs
104 . $tmp.mkfs
105 _check_ag 0
106 _check_ag -1
107
108 # success, all done
109 status=0
110 exit